package jaclib.memory.heap;

import jaclib.memory.heap.NativeHeapBuffer;

public final class NativeHeap {

   private int b;
   long peer;
   private boolean a;


   private final native void deallocateHeap();

   public final synchronized native void copy(long var1, long var3, int var5);

   protected final synchronized void finalize() throws Throwable {
      super.finalize();
      this.b();
   }

   final synchronized native void deallocateBuffer(int var1);

   final synchronized native void get(int var1, byte[] var2, int var3, int var4, int var5);

   final synchronized native int allocateBuffer(int var1, boolean var2);

   public final synchronized void b() {
      if(this.a) {
         this.deallocateHeap();
      }

      this.a = false;
   }

   final synchronized native void put(int var1, byte[] var2, int var3, int var4, int var5);

   public final NativeHeapBuffer a(int arg0, boolean arg1) {
      if(!this.a) {
         throw new IllegalStateException();
      } else {
         return new NativeHeapBuffer(this, this.allocateBuffer(arg0, arg1), arg0);
      }
   }

   final synchronized native long getBufferAddress(int var1);

   final synchronized boolean a() {
      return this.a;
   }

   private final native void allocateHeap(int var1);

   public NativeHeap(int arg0) {
      this.b = arg0 * 768051859;
      this.allocateHeap(this.b * 2079269787);
      this.a = true;
   }
}
